#ifndef _CAMEO_BOARD_INFO_H_
#define _CAMEO_BOARD_INFO_H_

#include <common.h>
#include <rtk_reg.h>
#if defined(CONFIG_RTL8390)
#include <rtk/mac/rtl8390/rtl8390_init.h>
#endif
#if defined(CONFIG_RTL8380)
#include <rtk/mac/rtl8380/rtl8380_init.h>
#endif

#define MAX_LINE_LENGTH_BYTES (64)
#define DEFAULT_LINE_LENGTH_BYTES (16)
#define DISP_LINE_LEN	16

typedef struct macro_board_info_params {
	char          *pBoard_id_with_Model_Name_Type;
	char          *pModel_Name;
	char          *pModel_Header_Name;
	char          *pHW_Version;
	char          *pModel_Show_Name;
    char          *pModel_Name_prompt;
    void          (*Cameo_hw_if_shutdown)(void);
    void          (*Cameo_hw_board_init)(void);
} t_macro_board_info_params;

enum cameo_board_support {
	CAMEO_HW_BOARD_SUPPORT,
	CAMEO_HW_BOARD_NOT_SUPPORT
};

typedef enum cm_switch_model_by_board_id_e {
    MODEL_BY_BOARD_ID_1         = 0,
    MODEL_BY_BOARD_ID_2         = 1,
    MODEL_BY_BOARD_ID_3         = 2,
    MODEL_BY_BOARD_ID_4         = 3,
    MODEL_BY_BOARD_ID_5         = 4,
    MODEL_BY_BOARD_ID_6         = 5,
    MODEL_BY_BOARD_ID_7         = 6,
    MODEL_BY_BOARD_ID_8         = 7,
    MODEL_NOT_FOUND             = 8,
} cm_switch_model_by_board_id_t;


extern int   Cameo_Single_IMG_HW_init(void);
extern void  Cameo_Single_IMG_board_info_init(void);
extern char* Cameo_Single_IMG_get_board_id(void);
extern void  Cameo_Single_IMG_set_board_id(char *pBoard_id_with_Model_Name_Type);
extern char* Cameo_Single_IMG_get_model_name(void);
extern char* Cameo_Single_IMG_get_model_header_name(void);
extern char* Cameo_Single_IMG_get_model_prompt(void);
extern char* Cameo_Single_IMG_get_hw_version(void);

extern int   Cameo_Single_IMG_HW_by_series_init(void);
extern char* Cameo_Single_IMG_get_model_name_by_series(void);
extern char* Cameo_Single_IMG_get_model_prompt_by_series(void);
extern char* Cameo_Single_IMG_get_ddp_show_model_name_by_series(void);
extern char* Cameo_Single_IMG_get_hw_version_by_series(void);
extern int   Cameo_Single_IMG_SFP_TX_by_series(uint);

extern void  Cameo_Single_IMG_HW_board_init(void);
extern void  Cameo_Single_IMG_HW_if_shutdown(void);
#endif /*end of _CAMEO_BOARD_INFO_H_*/
