#ifndef __CAMEO_BOOTCMD_TFTP_H__
#define __CAMEO_BOOTCMD_TFTP_H__

#include <configs/cameo/cameo_header.h>


#define IS_ASCII(c)        ((long)(c)<=0177)
#define INET_ADDR(s)       UtlInetAddr((const char *)s)
#define CAMEO_BOOTCMD_SUCCESS 1
#define CAMEO_BOOTCMD_FAILURE 0

int CheckIpValid(ulong ip);
int CheckMaskValid(ulong mask);
int CheckGateValid(ulong u4GatewayIp);

uint UtlInetAddr (const char * pc1Addr);
int UtlInetAton (const char * pc1Addr, uint * pInAddr);
#define _U	0x01	/* upper */
#define _L	0x02	/* lower */
#define _D	0x04	/* digit */
#define _C	0x08	/* cntrl */
#define _P	0x10	/* punct */
#define _S	0x20	/* white space (space/lf/tab) */
#define _X	0x40	/* hex digit */
#define _SP	0x80	/* hard space (0x20) */

extern unsigned char _ctype[];
#define __ismask(x) (_ctype[(int)(unsigned char)(x)])

#define isalnum(c)	((__ismask(c)&(_U|_L|_D)) != 0)
#define isalpha(c)	((__ismask(c)&(_U|_L)) != 0)
#define iscntrl(c)	((__ismask(c)&(_C)) != 0)
#define isdigit(c)	((__ismask(c)&(_D)) != 0)
#define isgraph(c)	((__ismask(c)&(_P|_U|_L|_D)) != 0)
#define islower(c)	((__ismask(c)&(_L)) != 0)
#define isprint(c)	((__ismask(c)&(_P|_U|_L|_D|_SP)) != 0)
#define ispunct(c)	((__ismask(c)&(_P)) != 0)
#define isspace(c)	((__ismask(c)&(_S)) != 0)
#define isupper(c)	((__ismask(c)&(_U)) != 0)
#define isxdigit(c)	((__ismask(c)&(_D|_X)) != 0)

#define isascii(c) (((unsigned char)(c))<=0x7f)
#define toascii(c) (((unsigned char)(c))&0x7f)

typedef struct img_hdr_struct{
	unsigned int      checksum;
	unsigned char     model[20];
	unsigned char     sig[16];
	unsigned char     partition;
	unsigned char     hdr_len;
	unsigned short    customer_sig;
	unsigned int      board_ver;
	unsigned int      flash_byte_cnt;
	unsigned char     boot[12];
}tImghdr;

char fwupgrade(void);
char fw_check_header(tImghdr *phdr);
char fw_check(void);

#define UDP_TFTPSRV_FWUPGRADE_PORT            0xFC05

#define MAX_FIRMWARE_IMAGE_SIZE		(1024*1024*8)
#define SYS_PRODUCT_NAME_LEN        20
#define IMAGE_BOOT                  "boot"
#define IMAGE_OS					"os"
#define IMAGE_CRAMFS				"squashfs"
#define MaxImageTypeLen				16
#define IMAGE_OS_TYPE				1
#define IMAGE_CRAMFS_TYPE			2

/* customer signature
   0 = generic
   1 = cameo
   2 = dlink
   3 = netgear
   */
#define CUSTOMER_SIGNATURE  CM_CUSTOMER_SIGNATURE

/**********************************************************************/
#define  UBOOOT_GO_RUNTIME_CMD  "reset"




#endif /* __CAMEO_BOOTCMD_TFTP_H__*/