/*
 * Copyright (C) 2009 Realtek Semiconductor Corp. 
 * All Rights Reserved.
 *
 * This program is the proprietary software of Realtek Semiconductor
 * Corporation and/or its licensors, and only be used, duplicated, 
 * modified or distributed under the authorized license from Realtek. 
 *
 * ANY USE OF THE SOFTWARE OTHER THAN AS AUTHORIZED UNDER 
 * THIS LICENSE OR COPYRIGHT LAW IS PROHIBITED. 
 *
 * $Revision: 1.1.1.1 $
 * $Date: 2016/08/04 09:29:56 $
 *
 * Purpose : SoC register definition
 *
 * Feature : Define the SoC and Peripherial components' registers
 *
 */
 
#ifndef __RTK_SOC_H__
#define __RTK_SOC_H__

/* include registers */
#include <soc/common/memory_reg.h>
#include <soc/common/spi_flash_reg.h>
#include <soc/common/nor_flash_reg.h>
#include <soc/common/eeprom_reg.h>
#include <soc/common/timer_wdog_reg.h>
#include <soc/common/interrupt_reg.h>
#include <soc/common/uart_reg.h>
#include <soc/common/gpio_reg.h>

/* include setting */
#include <soc/common/interrupt_setting.h>
#include <soc/common/time_setting.h>

#endif /* end of __RTK_SOC_H__ */

